package viliVonka;

import java.awt.Dimension;
import java.awt.Graphics;
import java.util.ArrayList;

import javax.swing.JPanel;

@SuppressWarnings("serial")
public class Panel extends JPanel
{
	private final static int eps = 2;
	private final static int BROJ_KAMIONA=2;
	private final static int BROJ_KOMBIJA=3;
	private Fabrika sever, zapad;
	private Skladiste centralno;
	private ArrayList<Drawable> sviElementi;
	private Prodavnica jug, jugoIstok;
	private ArrayList<Kombi> kombiji;
	private ArrayList<Kamion> kamioni;

	public Panel(int w, int h)
	{
		super();
		sviElementi = new ArrayList<>();
		kombiji = new ArrayList<>();
		kamioni=new ArrayList<>();
		setPreferredSize(new Dimension(w, h));
		repaint();
		sever = new Fabrika((w - Fabrika.size) / 2, Fabrika.size);
		zapad = new Fabrika(Fabrika.size, (h - Fabrika.size) / 2);
		centralno = new Skladiste((w - Skladiste.size) / 2,
				(h - Skladiste.size) / 2, 0);
		jug = new Prodavnica((w - Prodavnica.size) / 2,
				h - Prodavnica.size * 4, 0, 2000, this);

		jugoIstok = new Prodavnica((w - Prodavnica.size * 4), h
				- Prodavnica.size * 5, 0, 2000, this);

		for (int i = 0; i < BROJ_KOMBIJA; i++)
		{

			kombiji.add(new Kombi(Math.random() > 0.5 ? true : false,
					(w - Skladiste.size) / 2 + i * 10,
					(h - Skladiste.size) / 2 + 40, 2, this));

		}
		for(int i=0;i<BROJ_KAMIONA;i++)
		{
			kamioni.add(new Kamion(i%2==0,(w - Skladiste.size) / 2 + i * 20,(h - Skladiste.size) / 2 - 40,2,this));
			
			
		}
		sviElementi.add(jug);
		sviElementi.add(jugoIstok);
		sviElementi.add(sever);
		sviElementi.add(zapad);
		sviElementi.add(centralno);
		sviElementi.addAll(kombiji);
		sviElementi.addAll(kamioni);

		new Thread(jug).start();
		new Thread(jugoIstok).start();
		for (Kombi k : kombiji)
			new Thread(k).start();
		for(Kamion g:kamioni)
			new Thread(g).start();

	}

	public Prodavnica getProdavnicaOnSpot(int x, int y)
	{

		if (jug.getX() - x < eps && jug.getX() + Prodavnica.size - x > -eps
				&& jug.getY() - y < eps
				&& jug.getY() + Prodavnica.size - y > -eps)
			return jug;

		else if (jugoIstok.getX() - x < eps
				&& jugoIstok.getX() + Prodavnica.size - x > -eps
				&& jugoIstok.getY() - y < eps
				&& jugoIstok.getY() + Prodavnica.size - y > -eps)
			return jugoIstok;
		else
			return null;
	}

	public Skladiste getSkladisteOnSpot(int x, int y)
	{
		if (centralno.getX() - x < eps
				&& centralno.getX() + Skladiste.size - x > -eps
				&& centralno.getY() - y < eps
				&& centralno.getY() + Skladiste.size - y > -eps)
			return centralno;

		return null;

	}

	public boolean isFabrikaOnSpot(int x, int y)
	{
		if ((sever.getX() - x < eps && sever.getX() + Fabrika.size - x > -eps
				&& sever.getY() - y < eps && sever.getY() + Fabrika.size
				- y > -eps)
				|| (zapad.getX() - x < eps
						&& zapad.getX() + Fabrika.size - x > -eps
						&& zapad.getY() - y < eps && zapad.getY()
						+ Fabrika.size - y > -eps)

		)
			return true;

		else return false;

	}
	
	public Dimension getNorth()
	{
		
		return new Dimension(sever.getX(), sever.getY());
		
	}
	
	public Dimension getWest()
	{
		
		return new Dimension(zapad.getX(), zapad.getY());
		
	}
	
	

	public Dimension getSouth()
	{
		return new Dimension(jug.getX(), jug.getY());

	}

	public Dimension getSouthEast()
	{
		return new Dimension(jugoIstok.getX(), jugoIstok.getY());

	}

	public Dimension getWarehouse()
	{
		return new Dimension(centralno.getX(), centralno.getY());

	}

	@Override
	public void paint(Graphics g)
	{
		super.paint(g);
		for (Drawable d : sviElementi)
			d.drawSelf(g);

	}

}
