package viliVonka;

import java.awt.Color;
import java.awt.Graphics;
import java.util.concurrent.locks.Condition;
import java.util.concurrent.locks.ReentrantLock;

public class Prodavnica implements Drawable, Runnable
{

	private int x, y;
	public static final int size = 15;
	public static final int maxCapacity = 200;
	private int goods;
	private int dayInterval = 5;
	private Panel panel;
	private ReentrantLock lock=new ReentrantLock();
	private Condition isFull=lock.newCondition();
	public Prodavnica(int x, int y, int goods, int dayInterval, Panel panel)
	{
		this.panel = panel;
		this.x = x;
		this.y = y;
		this.goods = goods;
		this.dayInterval = dayInterval;

	}

	public int getX()
	{
		return x;
	}

	public void setX(int x)
	{
		this.x = x;
	}

	public int getY()
	{
		return y;
	}

	public void setY(int y)
	{
		this.y = y;
	}

	@Override
	public void drawSelf(Graphics g)
	{
		g.setColor(Color.BLUE);
		g.drawRect(x, y, size, size);
		
		if(goods==0)
		{
			g.setColor(Color.RED);
			g.drawLine(x, y, x+size, y+size);

			g.drawLine(x+size, y, x, y+size);
			
		}
		
		g.setColor(Color.BLACK);
		g.drawString(goods + "/" + maxCapacity, x + 15, y);

	}

	@Override
	public void run()
	{
		while (true)
		{
			lock.lock();
			if (goods - 30 >= 0)
			{
				goods -= 30;

			}
			else goods=0;
			
			if(maxCapacity-goods>=Kombi.MAX_CAPACITY)isFull.signalAll();
			lock.unlock();
			panel.repaint();
			try
			{
				Thread.sleep(dayInterval);
			} catch (InterruptedException e)
			{
				// TODO Auto-generated catch block
				e.printStackTrace();
			}

		}

	}

	public void addGoods(int goods)
	{
		lock.lock();
		while(this.goods+goods>maxCapacity)
		{
			try
			{
				isFull.await();
			} catch (InterruptedException e)
			{
				
			}
		
		}
		
		this.goods+=goods;
		isFull.signalAll();
		lock.unlock();
	}

}
