package viliVonka;

import java.awt.Color;
import java.awt.Graphics;
import java.util.concurrent.locks.Condition;
import java.util.concurrent.locks.ReentrantLock;

public class Skladiste implements Drawable
{
	private int x, y;
	public static final int size = 30;
	public static final int maxCapacity = 1000;
	private int goods;
	private ReentrantLock lock = new ReentrantLock();
	private Condition isEmpty = lock.newCondition();
	private Condition isFull = lock.newCondition();

	public Skladiste(int x, int y, int goods)
	{

		this.x = x;
		this.y = y;
		this.goods = goods;
	}

	public int getX()
	{
		return x;
	}

	public void setX(int x)
	{
		this.x = x;
	}

	public int getY()
	{
		return y;
	}

	public void setY(int y)
	{
		this.y = y;
	}

	@Override
	public void drawSelf(Graphics g)
	{
		g.setColor(Color.WHITE);
		g.fillRect(x, y, size, size);
		if(goods==0)
		{
			g.setColor(Color.RED);
			g.drawLine(x, y, x+size, y+size);

			g.drawLine(x+size, y, x, y+size);
			
		}
		g.setColor(Color.BLACK);
		g.drawString(goods + "/" + maxCapacity, x + 30, y);

	}

	public int getGoods()
	{

		return goods;
	}

	public void removeGoods(int amount)
	{
		lock.lock();
		while(goods-amount<0)
		{
			try
			{
				isEmpty.await();
			} catch (InterruptedException e)
			{
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
			
		}
		
		goods -= amount;
		isFull.signalAll();
		lock.unlock();
	}

	public void addGoods(int amount)
	{
		lock.lock();
		while(goods+amount>maxCapacity)
		{
			try
			{
				isFull.await();
			} catch (InterruptedException e)
			{
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
			
		}
		goods += amount;
		isEmpty.signalAll();
		lock.unlock();
	}

}
